unit Unit1;

interface

uses          
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,LeastSquareFit, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

function LSF(const Matrix:TMatrix; var coef:array of extended ):Boolean;
var i,j:integer; v: array of extended;
    Reg:TLeastSquareFit;
begin
  SetLength(v, high(Matrix)+2);
  Reg:=TLeastSquareFit.Create(high(Matrix)+1);
  for j:=0 to high(Matrix[0]) do   // add all observations
  begin
    v[0]:=1;        // column of 1's in the column '0' spot
    for i:=1 to high(matrix)+1 do v[i]:=Matrix[i-1,j];
    Reg.AddValue(v);
  end;
  result:=Reg.GetResult(coef);
  Reg.Free;
end;

procedure TForm1.Button1Click(Sender: TObject);
var Matrix:TMatrix;         // Array for observed data
    coef:array of extended; // Array for resulting coefficients
    k:integer;              // Number of variables
    n:integer;              // Number of observations
begin
    // Here, use k=2, n=4:
    k:=2; n:=4;
    SetLength(Matrix,k+1,n);
    SetLength(coef,k+1);

    // X1 data values:
    Matrix[0,0] := 1;
    Matrix[0,1] := 2;
    Matrix[0,2] := 4;
    Matrix[0,3] := 2;

    // X2 data values:
    Matrix[1,0] := 5;
    Matrix[1,1] := 3;
    Matrix[1,2] := 2;
    Matrix[1,3] := 6;

    // Y data values:
    Matrix[2,0] := 1;
    Matrix[2,1] := 4;
    Matrix[2,2] := 3;
    Matrix[2,3] := 4;

    if LSF(Matrix,coef) then
     ShowMessage('y='+floattostr(coef[0])+'+'+floattostr(coef[1])+'*X1+'+floattostr(coef[2])+'*X2')
    else  ShowMessage('no solution');
end;


end.
